<template>
  <div>
    <div v-if="stats">
      <h1 v-if="beforeDate">
        Statistics for {{ formatDate(beforeDate) }}
      </h1>

      <div class="dashboard">
        <div
          v-for="card in cards"
          :key="card.main.key"
          class="block"
        >
          <div class="block-text">
            <div
              v-if="card.main.key === 'totalVideoFilesSize'"
              class="value"
            >
              {{ formatBytes(stats[card.main.key]) }}
            </div>
            <div
              v-else
              class="value"
            >
              {{ formatNumber(stats[card.main.key]) }}
            </div>
            <div class="label">
              {{ card.main.label }}
            </div>
          </div>

          <chart
            v-if="statsWeek"
            :name="card.main.key"
            :data="statsWeek[card.main.key]"
            :type="card.graph.type"
          />
        </div>
      </div>
    </div>

    <div
      v-else
      class="empty-state"
    >
      <template v-if="beforeDate">
        <p>Sorry, we don't have any data for {{ formatDate(beforeDate) }}</p>
      </template>

      <template v-else>
        <div
          class="spinner-border text-secondary"
          role="status"
        >
          <span class="visually-hidden">Loading...</span>
        </div>
      </template>
    </div>
  </div>
</template>

<script lang="ts">
import { GlobalStats, GlobalStatsHistory } from '../../../shared/models/index.js'
import { getGlobalStatsHistory } from '../shared/instance-http.js'
import { defineComponent } from 'vue'
import Chart from '@/components/Chart.vue'
import { formatBytes, formatNumber } from '@/shared/utils.js'
import { ChartDataset, ChartData } from 'chart.js'

export default defineComponent({
  components: {
    Chart
  },

  data () {
    return {
      beforeDate: '',

      stats: null as GlobalStats,
      statsHistory: null as GlobalStatsHistory,

      statsWeek: {} as {
        [key: string]: ChartData<'line'>
      },

      cards: [
        {
          main: {
            key: 'totalInstances',
            label: 'Instances'
          },
          graph: {
            type: 'number' as const,
            data: [
              {
                key: 'totalInstances',
                label: 'Instances',
                yAxis: 'left' as const
              }
            ],
          }
        },
        {
          main: {
            key: 'totalUsers',
            label: 'Users'
          },
          graph: {
            type: 'number' as const,
            data: [
              {
                key: 'totalUsers',
                label: 'Users',
                yAxis: 'left' as const
              },
              {
                key: 'totalMonthlyActiveUsers',
                label: 'Active users',
                yAxis: 'left' as const
              }
            ],
          }
        },
        {
          main: {
            key: 'totalVideoComments',
            label: 'Comments'
          },
          graph: {
            type: 'number' as const,
            data: [
              {
                key: 'totalVideoComments',
                label: 'Comments',
                yAxis: 'left' as const
              }
            ],
          }
        },
        {
          main: {
            key: 'totalVideos',
            label: 'Videos'
          },
          graph: {
            type: 'number' as const,
            data: [
              {
                key: 'totalVideos',
                label: 'Videos',
                yAxis: 'left' as const
              }
            ],
          }
        },
        {
          main: {
            key: 'totalVideoViews',
            label: 'Views'
          },
          graph: {
            type: 'number' as const,
            data: [
              {
                key: 'totalVideoViews',
                label: 'Views',
                yAxis: 'left' as const
              }
            ],
          }
        },
        {
          main: {
            key: 'totalVideoFilesSize',
            label: 'Of video files'
          },
          graph: {
            type: 'bytes' as const,
            data: [
              {
                key: 'totalVideoFilesSize',
                label: 'Video files size',
                yAxis: 'left' as const
              }
            ],
          }
        }
      ]
    }
  },

  mounted () {
    this.getStats({
      beforeDate: this.$route?.query?.beforeDate as string,
      includeAll: this.$route?.query?.includeAll === 'true'
    })
  },

  methods: {
    formatNumber: (value: number) => formatNumber(value),
    formatBytes: (value: number, decimals = 0) => formatBytes(value, decimals),
    formatDate: (value: string) => new Date(value).toLocaleDateString(),

    async getStats (options: {
      beforeDate?: string
      includeAll?: boolean
    }) {
      const { beforeDate, includeAll } = options

      this.beforeDate = beforeDate || this.beforeDate

      const statsHistory = await getGlobalStatsHistory({ beforeDate, includeAll })

      if (statsHistory.data.length === 0) {
        this.statsHistory = this.stats = this.statsWeek = null

        return
      }

      this.stats = statsHistory?.data[0]?.stats
      this.statsHistory = statsHistory

      for (const card of this.cards) {
        this.statsWeek[card.main.key] = this.getDatasetAndLabels(card.graph.data)
      }
    },

    getDatasetAndLabels (graphData: { key: string, label: string, yAxis?: 'left' | 'right' }[]): ChartData<'line'> {
      // Compute difference with the previous days
      const lastHistory = this.statsHistory?.data?.slice(0, 90).reverse()
      const labels: string[] = []
      const datasets: ChartDataset<'line'>[] = []

      const colors = [
        {
          backgroundColor: '#f2690d2e',
          borderColor: '#febc6b',
        },
        {
          backgroundColor: '#8ef8fb',
          borderColor: '#4bd3d7'
        }
      ]

      for (let i = 0; i < graphData.length; i++) {
        const data = graphData[i]

        const dataset: ChartDataset<'line'> = {
          label: data.label,
          borderWidth: 2,
          cubicInterpolationMode: 'monotone',
          pointRadius: 0,
          data: [],
          fill: i === graphData.length - 1
            ? 'origin'
            : i + 1,

          ...colors[i]
        }

        if (data.yAxis === 'right') {
          Object.assign(dataset, { yAxisID: 'y-right' })
        }

        for (let dataHistory of lastHistory) {
          if (i === 0) {
            labels.push(new Date(dataHistory.date).toLocaleDateString())
          }

          dataset.data.push(dataHistory.stats[data.key])
        }

        datasets.push(dataset)
      }

      return {
        labels,

        datasets
      }
    }
  }
})
</script>

<style lang="scss" scoped>
  h1,
  p {
    color: rgba(0, 0, 0, 0.5);
    font-size: 18px;
    font-weight: 400;
    margin-bottom: 20px;
  }

  .dashboard {
    display: grid;
    gap: 20px;
    grid-template-columns: repeat(1, 1fr);

    @media screen and (min-width: 800px) {
      grid-template-columns: repeat(2, 1fr);
    }

    @media screen and (min-width: 1400px) {
      grid-template-columns: repeat(3, 1fr);
    }
  }

  .block {
    border-radius: 10px;
    background-color: white;
    color: gray;
    box-shadow: 1px 1px 1em rgba(0, 0, 0, 0.04);

    .block-text {
      text-align: left;
      margin: 5px 0 10px 10px;
    }

    .label {
      text-transform: uppercase;
      font-size: 0.8em;
    }

    .value {
      font-weight: bold;
      font-size: 1.5em;
    }
  }

  .empty-state {
    position: relative;
    top: -20px;
    display: flex;
    flex: 1;
    justify-content: center;
    align-items: center;
  }
</style>
